cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION FH(H,U)
      IMPLICIT NONE
      INCLUDE 'common.inc' 
      DOUBLE PRECISION FH,H,U
c PREMIERE COMPOSANTE DU FLUX
      FH = H*U
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION FQ(H,U)
      IMPLICIT NONE
      INCLUDE 'common.inc' 
      DOUBLE PRECISION FQ,H,U
c SECONDE COMPOSANTE DU FLUX 
      FQ = H*U**2.0d0+G*H**2.0d0/2.0d0
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE  calcul_s1(x,h,q,hold,qold)
      IMPLICIT NONE
      INCLUDE 'common.inc' 
C--- DESCRIPTION : Solveur de Godunov
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION x(*),h(*),hold(*),q(*),qold(*)
      INTEGER i
      DOUBLE PRECISION HG,UG,HD,UD,HP,UP,HM,UM
      DOUBLE PRECISION FH,FQ
      EXTERNAL FH,FQ
      DO i=2,n+1
        HG = HOLD(I-1)
        UG = QOLD(I-1)/HOLD(I-1)
        HD = HOLD(I)
        UD = QOLD(I)/HOLD(I)
        ! (HM,UM) Solution exacte du pb de riemann à l'interface x_{i-1/2}
        CALL riemann(0.0D0,HG,UG,HD,UD,HM,UM)

        HG = HOLD(I)
        UG = QOLD(I)/HOLD(I)
        HD = HOLD(I+1)
        UD = QOLD(I+1)/HOLD(I+1)
        ! (HP,UP) Solution exacte du pb de riemann à l'interface x_{i+1/2}
        CALL riemann(0.0D0,HG,UG,HD,UD,HP,UP)

c Eq masse
        h(i) = hold(i) - DT/DX*(FH(HP,UP)-FH(HM,UM))
c Eq moment
        Q(i) = Qold(i) - DT/DX*(FQ(HP,UP)-FQ(HM,UM))
      ENDDO
      RETURN
      END
C=======================================================================================================
c Solution du problème de Riemann pour les équations de Saint-Venant homogène
c=======================================================================================================
      subroutine riemann(xi,hl,ul,hr,ur,h,u)			
c=======================================================================================================
      double precision xi,hl,ul,hr,ur,h,u
      double precision  newton,zz
      external newton,zz 
!       A COMPLETER ICI ET LES ROUTINES ZZ ET DZ CORREPOND A LA FONCTION PHI COURBE D'ONDE 
      end subroutine riemann

c=======================================================================================================
c subroutines necessaires au solveur de riemann
c=======================================================================================================
	function zz(h1,h2)
	double precision  h1,h2
	double precision  zz
	double precision  g
        g=9.81d0
        if (h1.le.h2) then
	  zz=
	else
	  zz=
	end if
	end function zz
c-------------------------------------------------------------------------------------
	function dz(h1,h2)
	double precision   h1,h2
	double precision   dz
	double precision   g
        g=9.81d0
	if (h1.le.h2) then
	 dz=
	else
	 dz=
	end if
	end function dz
c-------------------------------------------------------------------------------------
c hstar est solution de l'equation f(h)=0
	function f(h,hl,ul,hr,ur)
	double precision  h,hl,ul,hr,ur
	double precision  f,zz,dz
        external zz,dz
	f=ur-ul+(h-hR)*zz(h,hR)+(h-hL)*zz(h,hL)
	end function f
c-------------------------------------------------------------------------------------
	function df(h,hl,ul,hr,ur)
	double precision  h,hl,ul,hr,ur
	double precision  df,zz,dz
        external zz,dz  
	df=zz(h,hR)+zz(h,hL)+(h-hR)*dz(h,hR)+(h-hL)*dz(h,hL)
	end function df
c-------------------------------------------------------------------------------------
c On resout f(h)=0 par la methode de Newton
	function newton(h,hl,ul,hr,ur)
	double precision  newton, h, dh,hl,ul,hr,ur
	double precision  f,df,eps
        external f,df
	integer  iter, itermax
        iter = 0
        itermax = 500000
        eps =  1.0d-10
	newton=h
	dh=1.0
	do while ((abs(dh).gt.eps).and.(iter.lt.itermax))
	dh=f(newton,hl,ul,hr,ur)/df(newton,hl,ul,hr,ur)
	newton=newton-dh
        iter = iter+1
	end do
        if (iter.ge.itermax) stop 'Newton iteration max atteinte!'
	end function newton
c-------------------------------------------------------------------------------------

