      SUBROUTINE  calcul_s2(x,h,q,hold,qold)
      IMPLICIT NONE
      INCLUDE 'common.inc' 
C--- DESCRIPTION : Schema cinetique avec la fonction indicatrice
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION x(*),h(*),hold(*),q(*),qold(*)
      INTEGER i
      DOUBLE PRECISION dzp,dzm
      DOUBLE PRECISION Z,F1,F2M,F2P
      EXTERNAL Z,F1,F2M,F2P
C--------------------------------------------------------------------------------------------------

      DO i=2,n+1
        DZM = Z(X(I+1))-Z(X(I))
        DZP = Z(X(I))-Z(X(I-1))
c Hauteur d'eau
        h(i) = hold(i) - dt/dx*
     &      (F1(HOLD(I),QOLD(I),HOLD(I+1),QOLD(I+1),DZM)
     &     - F1(HOLD(I-1),QOLD(I-1),HOLD(I),QOLD(I),DZP))
c Debit
        q(i) = qold(i) - dt/dx*
     &      (F2M(HOLD(I),QOLD(I),HOLD(I+1),QOLD(I+1),DZM)
     &     - F2P(HOLD(I-1),QOLD(I-1),HOLD(I),QOLD(I),-DZP))

      ENDDO
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION F1(HG,QG,HD,QD,DZ)
      IMPLICIT NONE
      INCLUDE 'common.inc'
C--- DESCRIPTION : CALCUL DE LA PREMIERE COMPOSANTE DU FLUX
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION F1,HG,QG,HD,QD,DZ
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION POS,NEG,SONM
      EXTERNAL POS,NEG
      DOUBLE PRECISION U,BORNE,BG,BD,TMP1,TMP2,SON
C--------------------------------------------------------------------------------------------------
      SONM  = sqrt(G*HG/2.0D0)
      U     = QG/HG
      BORNE = SQRT(2.0D0*G*POS(DZ))
      BG    = MAX(BORNE, (U - SONM * SQRT(3.0D0)))
      BD    = MAX(BORNE, (U + SONM * SQRT(3.0D0)))
      TMP1  = HG *( BD**2 - BG**2)/(4.0D0 * SONM * SQRT(3.0D0))

      SONM  = sqrt(G*HD/2.0D0)
      U     = QD/HD
      BORNE = -SQRT(2.0D0*G*NEG(DZ))
      BG    = MIN(BORNE, (U - SONM * SQRT(3.0D0)))
      BD    = MIN(BORNE, (U + SONM * SQRT(3.0D0)))
      TMP2  = HD *(BD**2 - BG**2)/(4.0D0 * SONM * SQRT(3.0D0))

      F1 = TMP1+TMP2
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION F2M(HG,QG,HD,QD,DZ)
      IMPLICIT NONE
      INCLUDE 'common.inc'
C--- DESCRIPTION : CALCUL DE LA SECONDE COMPOSANTE DU FLUX A GAUCHE DE L'INTERFACE
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION F2M,HG,QG,HD,QD,DZ
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION POS,NEG
      EXTERNAL POS,NEG
      DOUBLE PRECISION U,BORNE,BG,BD,TMP1,TMP2,TMP3,SONM
C--------------------------------------------------------------------------------------------------
      SONM  = sqrt(G*HG/2.0D0)
      U    = QG/HG
      BG   = POS(U - SONM * SQRT(3.0D0))
      BD   = POS(U + SONM * SQRT(3.0D0))
      TMP1 = HG *( BD**3 - BG**3)
     &     /(6.0D0 * SONM * SQRT(3.0D0))

      BORNE = SQRT(2.0D0*G*POS(DZ))
      BG    = MIN(BORNE, POS(U - SONM * SQRT(3.0D0)))
      BD    = MIN(BORNE, POS(U + SONM * SQRT(3.0D0)))
      TMP2  = HG *( BD**3 - BG**3)
     &      /(6.0D0 * SONM * SQRT(3.0D0))

      SONM   = sqrt(G*HD/2.0D0)
      U     = QD/HD
      BORNE = - SQRT(2.0D0*G*NEG(DZ))
      BG    = MIN(BORNE, U - SONM * SQRT(3.0D0))
      BD    = MIN(BORNE, U + SONM * SQRT(3.0D0))
      TMP3  = -HD *((POS(BD**2+2.0D0*G*DZ))**1.5D0 - 
     &              (POS(BG**2+2.0D0*G*DZ))**1.5D0)
     &      /(6.0D0 * SONM * SQRT(3.0D0))

      F2M = TMP1+TMP2+TMP3

      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION F2P(HG,QG,HD,QD,DZ)
      IMPLICIT NONE
      INCLUDE 'common.inc'
C--- DESCRIPTION : CALCUL DE LA SECONDE COMPOSANTE DU FLUX A GAUCHE DE L'INTERFACE
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION F2P,HG,QG,HD,QD,DZ
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION POS,NEG
      EXTERNAL POS,NEG
      DOUBLE PRECISION U,BORNE,BG,BD,TMP1,TMP2,TMP3,SONM
C--------------------------------------------------------------------------------------------------
      SONM =  sqrt(G*HD/2.0D0)
      U    = QD/HD
      BG   = NEG(U - SONM * SQRT(3.0D0))
      BD   = NEG(U + SONM * SQRT(3.0D0))
      TMP1 =  - HD *( BD**3 - BG**3)
     &     /(6.0D0 * SONM * SQRT(3.0D0))

      BORNE = SQRT(2.0D0*G*POS(DZ))
      BG    = MIN(BORNE, NEG(U - SONM * SQRT(3.0D0)))
      BD    = MIN(BORNE, NEG(U + SONM * SQRT(3.0D0)))
      TMP2  = - HD *( BD**3 - BG**3)
     &      /(6.0D0 * SONM * SQRT(3.0D0))

      SONM  = sqrt(G*HG/2.0D0)
      U     = QG/HG
      BORNE = SQRT(2.0D0*G*NEG(DZ))
      BG    = MAX(BORNE, U - SONM * SQRT(3.0D0))
      BD    = MAX(BORNE, U + SONM * SQRT(3.0D0))
      TMP3  = HG *((POS(BD**2+2.0D0*G*DZ))**1.5D0 - 
     &             (POS(BG**2+2.0D0*G*DZ))**1.5D0)
     &      /(6.0D0 * SONM * SQRT(3.0D0))

      F2P = TMP1+TMP2+TMP3
      RETURN
      END        
cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION POS(X)
      IMPLICIT NONE
      DOUBLE PRECISION POS,X
      POS = MAX(0.0D0,X)
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccc
      FUNCTION NEG(X)
      IMPLICIT NONE
      DOUBLE PRECISION NEG,X
      NEG = MAX(0.0D0,-X)
      RETURN
      END
        

