      SUBROUTINE  calcul_s3(x,h,q,hold,qold)
      IMPLICIT NONE
      INCLUDE 'common.inc' 
C--- DESCRIPTION : SCHEMA DE LAX-FRIEDRICH
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION x(*),h(*),hold(*),q(*),qold(*)
      INTEGER i
      DOUBLE PRECISION HG,UG,HD,UD,HM,UM,S
      DOUBLE PRECISION FLFH,FLFQ
      EXTERNAL FLFH,FLFQ
      DO i=2,n+1
      HG = HOLD(I-1)
      UG = QOLD(I-1)/HOLD(I-1)
      HM = HOLD(I)
      UM = QOLD(I)/HOLD(I)
      HD = HOLD(I+1)
      UD = QOLD(I+1)/HOLD(I+1)

      S = DX/DT
c Hauteur d'eau
        h(i) = hold(i) - DT/DX*(
     &    FLFH(HM,UM,HD,UD,S)-FLFH(HG,UG,HM,UM,S))
c Debit
        Q(i) = Qold(i) - DT/DX*(
     &    FLFQ(HM,UM,HD,UD,S)-FLFQ(HG,UG,HM,UM,S))
      ENDDO
      RETURN
      END
C--------------------------------------------------------------------------------------------------
      FUNCTION FLFH(HG,UG,HD,UD,S)
      IMPLICIT NONE
      INCLUDE 'common.inc'
C--- DESCRIPTION : FLUX DE LAX-FRIEDRICH (1ERE COMPOSANTE)
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION FLFH,HG,UG,HD,UD,FH,S
      EXTERNAL FH
      FLFH = FH(HG,UG)+FH(HD,UD)-S*(HD-HG)
      FLFH = FLFH/2.0D0
      RETURN
      END
C--------------------------------------------------------------------------------------------------
      FUNCTION FLFQ(HG,UG,HD,UD,S)
      IMPLICIT NONE
      INCLUDE 'common.inc'
C--- DESCRIPTION : FLUX DE LAX-FRIEDRICH (1ERE COMPOSANTE)
C--------------------------------------------------------------------------------------------------
      DOUBLE PRECISION FLFQ,HG,UG,HD,UD,FQ,QG,QD,S
      EXTERNAL FQ
      QG=HG*UG
      QD=HD*UD
      FLFQ = FQ(HG,UG)+FQ(HD,UD)-S*(QD-QG)
      FLFQ = FLFQ/2.0D0
      RETURN
      END



